#COMPILE EXE                                                                              
#DIM ALL                                                                     
'%Unicode = 1
#INCLUDE "appHelp.inc"
#INCLUDE "wIN32api.inc"
#INCLUDE "BBTodayAds.inc"                                                        
'#INCLUDE "debug.inc"
'#RESOURCE MANIFEST, 1, "xptheme.xml"                         
#RESOURCE "bbtodayAds.pbr"

'BBTodayAds.bas                                                   
'Special notes:
' - use [Config ads] to add new ads, new sales people, and ad prices
' - this file holds the array dataStor(1 to 15, 1 to 10, 1 to maxRows)
' - BBTodayAds.bbt contains the array data from listView, dataStor()              
' - current version of the program limited to 2 sales people
'   To add more, reports and advances need to be changed
'   add Next and Prev buttons to call reportPage(firstSalesPerson)
'   just sales people, up to 3 per page, recorded after the first page
' - maxRows is total number of ads covering all publications (tabs)
' - numRows is the number of ads for a specified publication (tab)                 
' - numView is the number of rows in view at any time
' - the currentRow is the absolute row number
' - the listview row number is (currentRow-topRow+1)
' - the storData routine stores data at index(currentRow)
' - dataStor(monthPub, colNo, rowNo)... Dim(1 to 15, 1 to 10, 1 to maxRows)
' - monthPub covers 12 months + 3 seasonal pubs
' - column labeled 'Number' is total months and ads/issue
' - processing columns 2 lists default percent commission (can override column 6)
' - processing columns 3 - 5 calculates default sale & commission (can override columns 7,9)
' - actual amount of sale paid i specified in column 7 and commission paid in column 10
' - This version is unicode aware with XPTheme manifest (unicode???)
' - with checkmarks and cue banner text in Advances
' - current version of the program limited to 2 sales people... but can be updated later
' - BBTodayAds.ini: saved data from configuring the ads
' - BBTodayAds.bbt: saved data from main listview, dataStor(1 to 15, 1 to 8, 1 to maxRows)
'                   saved data from Advance

'---------------------------------------------------------------------------------------------
'ver 1.60 08/18/2016
' - corrected need to not save even with no changes to data
' - fixed Shft+Del not clearing textbox columns
' - fixed mouse wheel scroll problem with cell value being cleared
' - fixed fatal error problem with report
' - added two more columns, 'Paid' and 'CommPd'
'ver 1.62 06/28/2017
' - added reporting for two sales people
' - added commissions and paid commissions to report for two sales people
' - added paid sales to report
'ver 1.70 08/23/2017
' - added scroll bar to magazine ad list and to config ad list
' - added two options for view/edit (default is view, no fear of changing anything)
' - added new dialog box for tracking advanced payments
'ver 1.75 09/21/2017 pending
' - replaced column 8 with adStatus combobox (TK, P/U, Greg, Proof, Ok)
' - for P/U, choose from pickup() = Monthly, Summer, OctFest, Ski
' - added runSheet, printing two columns: ads and status
'ver 1.76 03/07/2018
' - [Advance] corrected order problem - requires advOrder() to add in proper order
' - [Advance] corrected saving data associated with advance
' - [Advance] eliminated beginning balances, not needed
' - [Advance] changed selection of sales person
                         
FUNCTION PBMAIN()
   LOCAL nStyle AS LONG
   LOCAL sTitle AS STRING
   DIALOG FONT "Tahoma", 10
   sTitle = "Big Bear Today Ad Sales - ver " + $ver
   nStyle = %WS_CAPTION OR %WS_POPUP OR %DS_MODALFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW PIXELS, 0, sTitle, , , 900, 550, nStyle TO hMain  'wi = 830
   nStyle = %TCS_FIXEDWIDTH OR %TCS_FOCUSNEVER OR %WS_TABSTOP
   CONTROL ADD TAB, hMain, %IDC_MagazineTab, "", 0, 10, 810, 25, nStyle
   TAB INSERT PAGE hMain, %IDC_MagazineTab, 1, 0, "  Monthly    " TO hMonthly
   TAB INSERT PAGE hMain, %IDC_MagazineTab, 2, 0, "  Ski Mag    " TO hSkiMag
   TAB INSERT PAGE hMain, %IDC_MagazineTab, 3, 0, "  Summer Mag " TO hSummer
   TAB INSERT PAGE hMain, %IDC_MagazineTab, 4, 0, "  Oct Fest   " TO hOctFest
   TAB SELECT hMain, %IDC_MagazineTab, 1
   CONTROL ADD LABEL, hMain, %IDC_MagMonth, "", 350, 90, 200, 25
   nStyle = %CBS_DROPDOWNLIST OR %WS_VSCROLL OR %CBS_HASSTRINGS OR %WS_CHILD  OR %WS_TABSTOP
   DIM months(1 TO 12) AS STRING
   ARRAY ASSIGN months() = "January", "February", "March", "April", "May", "June", _
                           "July", "August", "September", "October", "November", "December"
   CONTROL ADD COMBOBOX, hMain, %IDC_MonthCombo, months(), 120, 50, 120, 250, nStyle
   COMBOBOX SELECT hMain, %IDC_MonthCombo, 1
   CONTROL HIDE hMain, %IDC_Pickup
   CONTROL ADD OPTION, hMain, %IDC_View, "View only", 20, 50, 100, 15
   CONTROL ADD OPTION, hMain, %IDC_Edit, "Edit items", 20, 70, 100, 15
   nStyle = %LVS_REPORT OR %LVS_NOSCROLL OR %WS_VISIBLE OR %LVS_SHOWSELALWAYS OR %WS_TABSTOP
   CONTROL ADD LISTVIEW, hMain, %IDC_Listview1, "", 20, 120, 810, 330, nStyle, %WS_EX_CLIENTEDGE
   CONTROL HANDLE hMain, %IDC_Listview1 TO hListview1
   gOrigListview1 = SetWindowLong(hListview1, %GWL_WndProc, CODEPTR(subclassListview1))
   LISTVIEW SET STYLEXX hMain, %IDC_Listview1, %LVS_EX_GRIDLINES OR %LVS_EX_FULLROWSELECT
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 1, "Ads", 150, 0
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 2, "Sales person", 135, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 3, "Number", 59, 2     '57
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 4, "Size", 67, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 5, "Color", 45, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 6, "Sale    ", 70, 1
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 7, "Paid    ", 70, 1
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 8, "Status", 70, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 9, "Comm   ", 70, 1
   LISTVIEW INSERT COLUMN hMain, %IDC_Listview1, 10, "CommPd ", 70, 1
   CONTROL ADD SCROLLBAR, hMain, %IDC_Scrollbar1, "", 830, 120, 20, 330, %SBS_VERT OR %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_ConfigBtn, "&Configure Ads", 20, 470, 100, 35
   CONTROL ADD BUTTON, hMain, %IDC_AdvanceBtn, "&Advances", 190, 470, 100, 35
   CONTROL ADD BUTTON, hMain, %IDC_ReportBtn, "&Show Report", 300, 470, 100, 35
   CONTROL ADD BUTTON, hMain, %IDC_runShtBtn, "&Run Sheet", 410, 470, 100, 35
   CONTROL ADD BUTTON, hMain, %IDC_HelpBtn1, "?", 520, 470, 30, 35
   CONTROL ADD STATUSBAR, hMain, %IDC_Statusbar1, "", 0, 0, 0, 0
   STATUSBAR SET PARTS hMain, %IDC_Statusbar1, 9999
   FONT NEW "Tahoma", 10, 0 TO hFont
   FONT NEW "Tahoma", 14, 0 TO hFont1
   CONTROL SET FONT hMain, %IDC_MagMonth, hFont1
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION                                                                                                            

CALLBACK FUNCTION mainProc()
   LOCAL i, j, k, m, n, nStyle, year, ans AS LONG
   LOCAL s, p, colr, sold, sMagMonth, sMag AS STRING                                                                     
   LOCAL sale, pct, commission, fn1, fn2 AS STRING
   LOCAL LpLvNm AS NM_LISTVIEW PTR
   STATIC savedRow, savedCol, savedTop, savedNumView, savedNumSalesPeople AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG 
         FONT NEW "Tahoma", 10, 0 TO hFont
         FONT NEW "Tahoma", 14, 0 TO hFont1
         FONT NEW "Tahoma", 8, 0 TO hFont2
         numAdSizes = 7: numAdStatus = 5: numSizes = 4*numAdSizes
         DIM adSizes(1 TO numAdSizes)
         DIM adStatus(1 TO numAdStatus)
         DIM pickup(1 TO 4)
         DIM colAds(1 TO numSizes)
         DIM BWAds(1 TO numSizes)
         DIM mag(1 TO 4)
         dim idCtrl(1 to 10)
         ARRAY ASSIGN mag() = "Monthly", "Ski", "Summer", "OctFest"
         ARRAY ASSIGN adSizes() = "Full", "Half", "Quarter", "third", "sixth", "eigth", "ninth"
         ARRAY ASSIGN adStatus() = "TK", "P/U", "Greg", "Proof", "Ok"
         ARRAY ASSIGN pickup() = "Mon", "Sum", "OctF", "Ski"
         array assign idCtrl() = %IDC_Textbox1, %IDC_Combobox1, %IDC_Textbox1, %IDC_Combobox2, %IDC_Textbox1, _ 
                                 %IDC_Textbox1, %IDC_Textbox1, %IDC_Combobox3, %IDC_Textbox1, %IDC_Textbox1
         currentRow = 1: currentCol = 2: lastRow = 1: lastCol = 2  'start with this cell
         tabNo = 1: lastTab = 1                                    'start with first tab
         monthNo = 1: lastMonth = 1                                'start with month of January
         topRow = 1: maxRows = 0
         s = COMMAND$(1)
         IF LEN(s) THEN
            dataFile = s: iniFile = s
            REPLACE ".bbt" WITH ".ini" IN iniFile
         ELSE
            iniFile = EXE.NAME$ + ".ini"   'reads maxRows, along with other values
            dataFile = EXE.NAME$ + ".bbt"  'extension named for Big Bear Today
         END IF
         IF ISFILE(iniFile) THEN
            n = PARSECOUNT(iniFile, "\") 'check if an archived file
            p = LCASE$(PARSE$(iniFile, "\", n - 1))
            IF p = "bbtodayads_archive" THEN archivedFile = -1 ELSE archivedFile = 0
            loadIniFile()
            IF ISFILE(dataFile) THEN loadDataFile()
         END IF
         helpFile = "bbTodayAds.ahp"
         IF maxRows = 0 THEN
            CONTROL ADD LABEL, CB.HNDL, %IDC_Begin, "Press [Configure Ads] to begin", 40, 300, 270, 30
            CONTROL SET FONT CB.HNDL, %IDC_Begin, hFont1
            CONTROL SET COLOR CB.HNDL, %IDC_Begin, %RGB_BLUE, %RGB_WHITE
         END IF
         CONTROL HANDLE CB.HNDL, %IDC_Scrollbar1 TO hScrollbar1
         adsChanged = 0: advDataChanged = 0: dataChanged = 0
         initialize()
         createTextbox1
         createCombobox1                                                 
         createCombobox2
         createCombobox3
         CONTROL ADD LISTBOX, CB.HNDL, %IDC_Pickup, pickup(), 620, 450, 70, 70, %WS_BORDER OR %WS_TABSTOP      '620, 450
         CONTROL HANDLE CB.HNDL, %IDC_Pickup TO hPickup
         CONTROL HIDE CB.HNDL, %IDC_Pickup
         CONTROL SET OPTION CB.HNDL, %IDC_View, %IDC_View, %IDC_Edit: viewOnly = 1
         showStatus1 0
         year = VAL(RIGHT$(DATE$, 4))
         IF storedYr = 0 THEN storedYr = year
         IF storedYr < year AND NOT archivedFile THEN
            n = whatNow() 'time to archive
            IF n THEN archive_reset
            IF endProg THEN DIALOG END CB.HNDL
         END IF
         gbGrid_GoToCurrentCell1(1)
         TAB GET TEXT CB.HNDL, %IDC_MagazineTab, tabNo TO sMag
         sMagMonth = TRIM$(sMag) + " - " + months(monthNo)
         CONTROL SET TEXT CB.HNDL, %IDC_MagMonth, sMagMonth
         setAds
         LISTVIEW GET TEXT CB.HNDL, %IDC_Listview1, 1, 2 TO s
         gbGrid_GoToCurrentCell1(0)
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), 0, GetCurrentThreadID)
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500
         CONTROL SET FOCUS CB.HNDL, %IDC_Listview1
         currentDlg = 1
      CASE %WM_VSCROLL
         IF numRows < numview THEN EXIT FUNCTION
         scrolling = 1
         m = topRow - currentRow
         si.nPos = topRow
         SELECT CASE LOWRD(CB.WPARAM)
            CASE %SB_LINEDOWN
               si.nPos = si.nPos + 1
            CASE %SB_PAGEDOWN
               si.nPos = si.nPos + si.nPage
            CASE %SB_LINEUP
               si.nPos = si.nPos - 1
            CASE %SB_PAGEUP
               si.nPos = si.nPos - si.nPage
            CASE %SB_THUMBPOSITION, %SB_THUMBTRACK
               si.nPos = HIWRD(CB.WPARAM)
            CASE ELSE
               EXIT FUNCTION
         END SELECT
         'ensure range is correct with following two statements
         IF si.nPos < 1 THEN si.nPos = 1: EXIT FUNCTION
         IF si.nPos > si.nMax THEN si.nPos = si.nMax: EXIT FUNCTION
         IF k AND (si.nPos + si.nPage > si.nMax) THEN si.nPos = si.nMax
         si.cbSize = SIZEOF(si)
         si.fMask = %SIF_POS OR %SIF_PAGE
         SetScrollInfo BYVAL hScrollbar1, BYVAL %SB_CTL, si, 1
         topRow = si.nPos
         currentRow = topRow - m
         lastRow = currentRow: scrollView1
         scrolledText
         IF viewOnly = 0 THEN CONTROL SET FOCUS hListview1, %IDC_Textbox1
      CASE %WM_NOTIFY
         SELECT CASE CB.NMID
            CASE %IDC_MagazineTab 'clicked on tab
               gbGrid_GoToCurrentCell1(0)
               currentRow = 1: currentCol = 2
               TAB GET SELECT CB.HNDL, %IDC_MagazineTab TO tabNo
               TAB GET TEXT CB.HNDL, %IDC_MagazineTab, tabNo TO sMag
               sMagMonth = TRIM$(sMag)
               IF tabNo = 1 THEN 'monthly, show months combobox
                  CONTROL NORMALIZE CB.HNDL, %IDC_MonthCombo
                  sMagMonth = sMagMonth + " - " + months(monthNo)
               ELSE
                  CONTROL HIDE CB.HNDL, %IDC_MonthCombo
               END IF
               CONTROL SET TEXT CB.HNDL, %IDC_MagMonth, sMagMonth
               IF lasttab THEN lastTab = 0 ELSE lastTab = 1
               IF tabNo <> lastTab THEN
                  lastTab = tabNo
                  listAdSales()
                  currentRow = 1: currentCol = 2
                  gbGrid_GoToCurrentCell1(0)
               END IF
            CASE %IDC_Listview1
               SELECT CASE CB.NMCODE
                  CASE %NM_SETFOCUS
                     CONTROL SET FOCUS hListView1, %IDC_Textbox1
                  CASE %LVN_COLUMNCLICK
                     DIALOG POST CB.HNDL, %WM_USER+500, 0, 0
                  CASE %NM_CLICK, %NM_RCLICK
                     updateCell
                     scrolling = 0
                     LpLvNm = CB.LPARAM
                     currentRow = topRow + @LpLvNm.iITem
                     currentCol = @LpLvNm.iSubItem + 1
                     IF viewOnly THEN EXIT FUNCTION
                     IF currentCol = 1 THEN INCR currentCol
                     IF currentCol = 8 THEN
                        LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 8 TO s
                        IF LEFT$(s, 3) = "P/U" THEN
                           n = 2: pickupTxt = MID$(s, 5): adStatus(2) = s
                           COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, adStatus(2)
                           CONTROL NORMALIZE hMain, %IDC_Pickup
                           ARRAY SCAN pickup(), = pickupTxt, TO pickup0
                           LISTBOX SELECT hMain, %IDC_Pickup, pickup0
                        ELSE
                           ARRAY SCAN adStatus(), = s, TO n
                        END IF
                        COMBOBOX SELECT hListview1, %IDC_Combobox3, n
                        setFocus hCombobox3: lastText = s
                     ELSEIF lastCol = 8 THEN
                        LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 8 TO cellText
                        IF s = "P/U" THEN cellText = lastText
                     END IF
                     gbGrid_GoToCurrentCell1(0)
               END SELECT
         END SELECT
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDOK 'return key brings us here
               IF currentCol = 2 THEN
                  COMBOBOX GET SELECT hListview1, %IDC_ComboBox1 TO n
                  IF n THEN cellText = salesPeople1(n)
               ELSEIF currentCol = 8 THEN
                  COMBOBOX GET SELECT hListview1, %IDC_Combobox3 TO n
                  IF n THEN cellText = adStatus(n)
                  IF n = 2 AND cellText = "P/U" THEN
                     cellText = lastText
                  END IF
               END IF
               lastCol = currentCol: INCR currentCol
               IF currentCol > 10 THEN currentCol = 2
               gbGrid_GoToCurrentCell1(0)
            CASE %IDC_MonthCombo
               IF CB.CTLMSG = %CBN_CLOSEUP THEN
                  DIALOG POST CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
                  gbGrid_GoToCurrentCell1(0)
                  currentRow = 1: currentCol = 2
                  COMBOBOX GET SELECT CB.HNDL, CB.CTL TO monthNo
                  IF monthNo <> lastMonth THEN
                     lastMonth = monthNo
                     listAdSales()
                  END IF
                  currentRow = 1: currentCol = 2
                  gbGrid_GoToCurrentCell1(0)
                  TAB GET TEXT CB.HNDL, %IDC_MagazineTab, tabNo TO sMag
                  sMagMonth = TRIM$(sMag) + " - " + months(monthNo)
                  CONTROL SET TEXT CB.HNDL, %IDC_MagMonth, sMagMonth
               END IF
            CASE %IDC_Pickup
               IF CB.CTLMSG = %LBN_SELCHANGE OR CB.CTLMSG = %LBN_DBLCLK THEN
                  IF pickup0 = 0 THEN pickup0 = 1
                  LISTBOX GET SELECT CB.HNDL, %IDC_Pickup TO n
                  pickupTxt = pickup(n): adStatus(2) = "P/U " + pickupTxt
                  COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, adStatus(2)
                  COMBOBOX SELECT hListview1, %IDC_Combobox3, 2
                  LISTVIEW SET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 8, adStatus(2)
                  setFocus hCombobox3
               END IF
            CASE %IDC_View, %IDC_Edit
               IF CB.CTL = %IDC_View THEN
                  viewOnly = 1
                  CONTROL HIDE CB.HNDL, %IDC_Pickup
                  CONTROL HIDE hListview1, %IDC_Combobox1
                  CONTROL HIDE hListview1, %IDC_Textbox1
                  CONTROL SET FOCUS CB.HNDL, %IDC_ListView1
                  showStatus1
               ELSE
                  viewOnly = 0
                  LISTVIEW GET TEXT CB.HNDL, %IDC_Listview1, currentRow-topRow+1, currentCol TO s
                  IF currentCol = 8 AND LEFT$(s, 3) = "P/U" THEN
                     LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 8 TO s
                     COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, s
                     COMBOBOX SELECT hListview1, %IDC_Combobox3, 2
                     adStatus(2) = s
                     CONTROL NORMALIZE CB.HNDL, %IDC_Pickup
                     s = MID$(s, 5): ARRAY SCAN pickup(), = s, TO pickup0
                     LISTBOX SELECT CB.HNDL, %IDC_Pickup, pickup0
                  END IF 
                  CONTROL NORMALIZE hListview1, idCtrl(currentCol)
                  showStatus1 currentCol
               END IF
               lastRow = currentRow: lastCol = currentCol
               gbGrid_GoToCurrentCell1(0)
            CASE %IDC_ConfigBtn
               savedRow = currentRow: savedCol = currentCol
               savedTop = topRow: savedNumView = numView
               savedNumSalesPeople = numSalesPeople
               savedMaxRows = maxRows
               configAds()
               currentDlg = 1
               currentRow = savedRow: currentCol = savedCol: lastCol = currentCol
               topRow = savedTop: numView = savedNumView: maxRows = savedMaxRows
               IF adsChanged THEN
                  initialize() '...remember, array sizes may have been changed
                  setAds
                  REDIM salesPeople1(1 TO numSalesPeople+1)
                  FOR i = 1 TO numSalesPeople
                     salesPeople1(i) = salesPeople(i)
                  NEXT i: salesPeople1(numSalesPeople+1) = "Owner"
                  IF numSalesPeople <> savedNumSalesPeople THEN
                     CONTROL KILL hListview1, %IDC_Combobox1
                     createCombobox1
                  END IF
                  gbGrid_GoToCurrentCell1(0)
               END IF
               IF maxRows THEN CONTROL KILL CB.HNDL, %IDC_Begin
               CONTROL SET FOCUS hListview1, %IDC_TextBox1
            CASE %IDC_AdvanceBtn
               updateCell
               advances
               CONTROL SET FOCUS hListview1, %IDC_TextBox1
            CASE %IDC_ReportBtn
               updateCell
               report
               CONTROL SET FOCUS hListview1, %IDC_TextBox1
            CASE %IDC_RunShtBtn
               printRunSheet
            CASE %IDCANCEL 'ESC key brings us here
               IF lastCol = 2 THEN
                  ARRAY SCAN salesPeople1(), = lastText, TO n
                  'COMBOBOX SELECT hListview1, %IDC_Combobox1, n
                  IF n THEN cellText = salesPeople1(n) ELSE cellText = ""
               ELSEIF lastCol = 4 THEN
                  ARRAY SCAN adSizes(), = lastText, TO n
                  'COMBOBOX SELECT hListview1, %IDC_Combobox2, n
                  IF n THEN cellText = adSizes(n) ELSE cellText = ""
               ELSEIF lastCol = 8 THEN
                  s = lastText
                  IF LEFT$(lastText, 3) = "P/U" THEN
                     n = 2: adStatus(2) = s: pickupTxt = MID$(s, 5)
                     COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, adStatus(2)
                     CONTROL NORMALIZE hMain, %IDC_Pickup
                     ARRAY SCAN pickup(), = pickupTxt, TO pickup0
                     LISTBOX SELECT hMain, %IDC_Pickup, pickup0
                  ELSE
                     ARRAY SCAN adStatus(), = lastText, TO n
                  END IF
                  'IF n THEN COMBOBOX SELECT hListview1, %IDC_Combobox3, n
               END IF
               COMBOBOX SELECT hListview1, idCtrl(lastCol), n
            CASE %IDC_HelpBtn1
               IF ISFILE(helpFile) THEN
                  appHelp helpFile, "", hMain
               ELSE
                  MSGBOX "Help file not found", %MB_ICONERROR, helpFile
               END IF
               CONTROL SET FOCUS hListview1, %IDC_TextBox1
               CONTROL SEND CB.HNDL, CB.CTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END SELECT
      CASE %WM_DESTROY
         UnhookWindowsHookEx ghKbdHook
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            'adsChanged = 0: dataChanged = 0 ''''''''''''''''''''''''''''''''''''''''''==============
            IF adsChanged OR dataChanged THEN
               s = "Do you want to save the files?"
               ans = MSGBOX(s, %MB_YESNOCANCEL, "Ads/data have been changed")
               IF ans = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
               IF ans = %IDYES THEN
                  'backup program files while program is being checked out
                  '"BBTodayAds.ini" --> "BBTodayAds_date_time.ini"
                  '"BBTodayAds.bbt" --> "BBTodayAds_date_time.bbt"
                  s = STRDELETE$(DATE$, 7, 2) +"_"+LEFT$(TIME$, 6)
                  s = "_" + REMOVE$(s, ANY "-:")
                  fn1 = STRINSERT$(iniFile, s, 11)
                  fn2 = STRINSERT$(dataFile, s, 11)
                  IF adsChanged THEN
                     saveIniFile
                     FILECOPY dataFile, fn1
                  END IF
                  IF dataChanged THEN
                     updateCell
                     saveDataFile
                     FILECOPY dataFile, fn2
                  END IF
               END IF
            END IF
         END IF
   END SELECT
END FUNCTION

FUNCTION KeyboardHook(BYVAL iCode AS INTEGER, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS DWORD
   'up and down keyboard keys to scroll view only text
   LOCAL h AS LONG
   STATIC nCount AS LONG
   IF viewOnly = 0 THEN EXIT FUNCTION
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParm, lParm): EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR nCount: IF nCount = 2 THEN nCount = 0: EXIT FUNCTION
   IF scrolling THEN EXIT FUNCTION
   IF currentDlg <> 1 THEN EXIT FUNCTION
   SELECT CASE wParm
      CASE %VK_Up
         IF topRow > 1 AND currentRow > 1 THEN
            DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEUP, 0
         END IF
      CASE %VK_Down
         IF (topRow < numRows - numView + 1) AND currentRow < numRows THEN
            DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEDOWN, 0
         END IF
   END SELECT
   scrolling = 0
END FUNCTION

FUNCTION subclassListview1(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS LONG
  LOCAL m, n, k AS LONG
   LOCAL s AS STRING
   LOCAL rc AS rect
   SELECT CASE Msg
      CASE %WM_COMMAND
         IF viewOnly THEN EXIT SELECT
         'keep selections for the three comboboxes (they cannot be handled the same as the textbox)
         IF HI(INTEGER, wParm) = %CBN_CLOSEUP OR HI(INTEGER, wParm) = %CBN_SELCHANGE THEN 
            IF currentCol = 2 THEN  'sales people combobox
               COMBOBOX GET SELECT hListview1, %IDC_ComboBox1 TO n
               IF n THEN cellText = salesPeople1(n): choice2 = n                             
            ELSEIF currentCol = 4 THEN 'adSizes combobox
               COMBOBOX GET SELECT hListview1, %IDC_ComboBox2 TO n
               IF n THEN cellText = adSizes(n): choice4 = n
            ELSEIF currentCol = 8 THEN 'adStatus combobox
               COMBOBOX GET SELECT hListview1, %IDC_ComboBox3 TO n
               IF n THEN cellText = adStatus(n) 'else cellText = ""                   
               IF n = 2 THEN
                  COMBOBOX SELECT hListview1, %IDC_ComboBox3, 2
                  CONTROL NORMALIZE hMain, %IDC_Pickup
                  LISTBOX SELECT hMain, %IDC_Pickup, pickup0
                  setFocus hCombobox3
               ELSE
                  CONTROL HIDE hMain, %IDC_Pickup
                  setFocus hCombobox3
               END IF
            END IF
         END IF
      CASE %WM_MOUSEWHEEL 'mouse wheel scrolling
         SELECT CASE HI(INTEGER, wParm) 'note the use of Integer
            CASE > 0  'wheel up
               IF topRow > 1 AND currentRow > 1 THEN
                  DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEUP, 0
               END IF
            CASE < 0  'wheel down
               IF (topRow < numRows - numView + 1) AND currentRow < numRows THEN
                  DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEDOWN, 0
               END IF
         END SELECT
         scrolledText
         FUNCTION = 1: EXIT FUNCTION
   END SELECT
   FUNCTION = CallWindowProc(gOrigListview1, hWnd, Msg, wParm, lParm)
END FUNCTION

FUNCTION subclassTextbox1(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS LONG
   LOCAL i, n, nOpt, ans AS LONG
   LOCAL s, ss AS STRING
   SELECT CASE Msg
      IF viewOnly THEN EXIT SELECT
      Case %WM_ContextMenu
         exit function  'no Microsoft textbox menu
      CASE %WM_CHAR
         IF currentCol = 5 THEN
            IF wParm = %VK_Space OR wParm = ASC("c") OR wParm = ASC("C") THEN
               CONTROL GET TEXT hListView1, %IDC_TextBox1 TO s
               IF LEN(s) THEN s = "" ELSE s = "c"
               CONTROL SET TEXT hListView1, %IDC_TextBox1, s
            END IF
            FUNCTION = 1: EXIT FUNCTION
         ELSEIF currentCol <> 2 AND currentCol <> 4 AND currentCol <> 8THEN
         'filter thru only numbers and one decimal point for editable cells
            IF ISFALSE INSTR("0123456789." + $BS, CHR$(wParm)) THEN EXIT FUNCTION
            IF CHR$(wParm) = "." THEN
               CONTROL GET TEXT hListView1, %IDC_TextBox1 TO s
               IF INSTR(s, ".") THEN EXIT FUNCTION  'only one decimal allowed
            END IF
         END IF
      CASE %WM_KEYDOWN 
         IF (GetKeyState(%VK_SHIFT) AND &H8000) THEN
            SELECT CASE wParm
               CASE %VK_Up
                  IF currentRow = topRow THEN
                     n = currentRow
                     CONTROL GET TEXT hListview1, %IDC_TextBox1 TO s
                     DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEUP, 0
                     CONTROL SET TEXT hListview1, %IDC_TextBox1, s
                     lastRow = n: nOpt = 2
                  ELSEIF currentRow > 1 THEN
                     DECR currentRow: nOpt = 2
                  END IF
               CASE %VK_Down
                  IF currentRow = topRow + numview - 1 THEN
                     n = currentRow
                     CONTROL GET TEXT hListview1, %IDC_TextBox1 TO s
                     DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEDOWN, 0
                     CONTROL SET TEXT hListview1, %IDC_TextBox1, s
                     lastRow = n: nOpt = 2
                  ELSEIF currentRow < numRows THEN
                     INCR currentRow: nOpt = 2
                  END IF
               CASE %VK_Left
                  CurrentCol = MAX(2,CurrentCol-1): nOpt = 1
               CASE %VK_Right
                  nOpt = 1: INCR currentCol: IF currentCol > 10 THEN currentCol = 2
               CASE %VK_Pgup
                  CurrentRow = MAX(1, CurrentRow-numView+1): nOpt = 2
               CASE %VK_PgDn
                  CurrentRow = MIN(numRows, CurrentRow+numView-1): nOpt = 2
               CASE %VK_Home
                  currentRow = 1: nOpt = 2
               CASE %VK_End
                  currentRow = numRows: nOpt = 2
               CASE %VK_Delete
                  CONTROL SET TEXT hListview1, %IDC_TextBox1, ""
            END SELECT
            IF nOpt THEN gbGrid_GoToCurrentCell1(nOpt - 1)
            scrolling = 0
            FUNCTION = 1: EXIT FUNCTION
         ELSE
            SELECT CASE wParm
               CASE %VK_S
                  IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN
                     ans = MSGBOX("Save file now?", %MB_YESNO, dataFile)
                     IF ans = %IDYES THEN saveDataFile
                  END IF
               CASE %VK_DELETE
                  IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN
                     LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 1 TO ss
                     s = "Remove all data for this ad?"
                     ans = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Remove Data for " + ss)
                     IF ans = %IDYES THEN
                        FOR i = 2 TO 10
                           LISTVIEW SET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, i, ""
                           storData(currentRow, i, "")
                        NEXT i
                        currentCol = 2: gbGrid_GoToCurrentCell1(0)
                     END IF
                     FUNCTION = 1: EXIT FUNCTION
                  END IF
            END SELECT
         END IF
   END SELECT
   FUNCTION = CallWindowProc(gOrigTextbox1, hWnd, Msg, wParm, lParm)
END FUNCTION

FUNCTION subclassCombobox1(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParm AS LONG, BYVAL lParm AS LONG) AS LONG
   LOCAL i, n, k, ans, nCombo, nOpt AS LONG
   LOCAL s, ss AS STRING
   IF viewOnly THEN EXIT FUNCTION
   SELECT CASE Msg
      CASE %WM_KEYDOWN
         IF (GetKeyState(%VK_SHIFT) AND &H8000) THEN
            SELECT CASE wParm
               CASE %VK_Up
                  CONTROL GET TEXT hListview1, idCtrl(currentCol) TO s
                  IF currentRow = topRow THEN
                     n = currentRow
                     DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEUP, 0
                     lastRow = n: cellText = s: nOpt = 2
                  ELSEIF currentRow > 1 THEN
                     DECR currentRow: nOpt = 2
                  END IF
               CASE %VK_Down                                                                       
                  control get text hListview1, idCtrl(currentCol) TO s 
                  IF currentRow = topRow + numview - 1 THEN
                     n = currentRow
                     DIALOG SEND hMain, %WM_VSCROLL, %SB_LINEDOWN, 0
                     lastRow = n: cellText = s: nOpt = 2
                  ELSEIF currentRow < numRows THEN
                     INCR currentRow: cellText = s: nOpt = 2
                  END IF
               CASE %VK_Left
                  CurrentCol = MAX(2,CurrentCol-1): nOpt = 1  'gbGrid_GoToCurrentCell1(0)
               CASE %VK_Right
                  CurrentCol = MIN(10,CurrentCol+1): nOpt = 1  'gbGrid_GoToCurrentCell1(0)
               CASE %VK_Pgup
                  CurrentRow = MAX(1, CurrentRow-numView+1): nOpt = 2  'gbGrid_GoToCurrentCell1(1)
               CASE %VK_PgDn
                  CurrentRow = MIN(numRows, CurrentRow+numView-1): nOpt = 2  'gbGrid_GoToCurrentCell1(1)
               CASE %VK_Home
                  currentRow = 1: nOpt = 2  'gbGrid_GoToCurrentCell1(1)
               CASE %VK_End
                  currentRow = numRows: nOpt = 2  'gbGrid_GoToCurrentCell1(1)
            END SELECT
            IF currentcol = 8 THEN
               COMBOBOX GET SELECT hListview1, %IDC_Combobox3 TO n
               IF n THEN
                  cellText = adStatus(n)
                  LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 8, cellText
               END IF
            END IF
            IF nOpt THEN gbGrid_GoToCurrentCell1(nOpt - 1)
            FUNCTION = 1: EXIT FUNCTION
         ELSEIF currentCol = 8 AND (GetKeyState(%VK_CONTROL) AND &H8000) THEN
            'ctrl+Up/Down for selecting pickup mag
            IF pickup0 = 0 THEN EXIT FUNCTION
            SELECT CASE wParm
               CASE %VK_UP
                  DECR pickup0: IF pickup0 < 1 THEN pickup0 = 4
               CASE %VK_DOWN
                  INCR pickup0: IF pickup0 >4 THEN pickup0 = 1
            END SELECT
            s = "P/U " + pickup(pickup0)
            COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, s
            COMBOBOX SELECT hListview1, %IDC_Combobox3, 2
            adStatus(2) = s
            LISTBOX SELECT hMain, %IDC_Pickup, pickup0
            FUNCTION = 1: EXIT FUNCTION
         ELSE
            SELECT CASE wParm
               CASE %VK_S 'save file
                  IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN
                     ans = MSGBOX("Save file now?", %MB_YESNO, dataFile)
                     IF ans = %IDYES THEN saveDataFile
                  END IF
               CASE %VK_DELETE
                  IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN
                     nCombo = CHOOSE&(currentCol,%IDC_Combobox1,0,0,%IDC_Combobox2,0,0,0,%IDC_Combobox3)
                     LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 1 TO ss
                     s = "Remove all data for this ad?"
                     ans = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Remove Data for " + ss)
                     IF ans = %IDYES THEN
                        FOR i = 2 TO 10
                           CONTROL HIDE hListview1, nCombo
                           LISTVIEW SET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, i, ""
                           storData(currentRow, i, "")
                        NEXT i
                        currentCol = 2: gbGrid_GoToCurrentCell1(0)                             
                     END IF
                     FUNCTION = 1: EXIT FUNCTION
                  END IF
            END SELECT
         END IF
   END SELECT
   IF currentCol = 2 THEN
      FUNCTION = CallWindowProc(gOrigCombobox1, hWnd, Msg, wParm, lParm)
   ELSEIF currentCol = 4 THEN
      FUNCTION = CallWindowProc(gOrigCombobox2, hWnd, Msg, wParm, lParm)
   ELSEIF currentCol = 8 THEN
      FUNCTION = CallWindowProc(gOrigCombobox3, hWnd, Msg, wParm, lParm)
   END IF
END FUNCTION

SUB initialize()
   'processed when program begins, is reset for new year, or returns from [Config]
   LOCAL i, n AS LONG
   'initialize salesPeople1() which includes owner with sales people
   REDIM salesPeople1(1 TO numSalesPeople+1)
   FOR i = 1 TO numSalesPeople
      salesPeople1(i) = salesPeople(i)
   NEXT i: salesPeople1(numSalesPeople+1) = "Owner"
   numView = Listview_GetCountPerPage(hListview1)
   IF maxRows THEN
      REDIM index(1 TO maxRows)
      FOR i = 1 TO maxRows
         IF LEN(stor(tabNo + 1, i)) THEN INCR n: index(n) = i
      NEXT i
      numRows = n
   END IF
   updateScrollInfo1(hScrollbar1)
END SUB

SUB updateScrollInfo1(hScrollbar1 AS LONG)
   si.cbSize = LEN(si)
   si.fMask  = %SIF_ALL
   si.nMin   = 1
   si.nMax   = MAX(1, numRows + 1 - numView)
   si.nPage  = MAX(1, (si.nMax - si.nMin) / 6)
   si.nPos   = topRow
   SetScrollInfo BYVAL hScrollbar1, BYVAL %SB_CTL, si, 1
END SUB

SUB gbGrid_GoToCurrentCell1(EnSureVisible AS LONG)
   'move textbox selector to next item
   LOCAL i, j, k AS LONG
   LOCAL s AS STRING
   LOCAL rc AS Rect
   IF viewOnly THEN EXIT SUB
   IF numRows = 0 THEN EXIT SUB
   IF currentRow <> lastRow OR currentCol <> lastCol THEN 
      CONTROL HIDE hMain, %IDC_Pickup                                    
      control hide hListview1, idCtrl(lastCol)
      updateCell
   END IF 
   showStatus1 currentCol
   'set the text for the new cell before moving to avoid a visual flicker
   scrolledText
   LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, currentCol TO cellText
   lastRow = currentRow: lastCol = currentCol: lastText = cellText
   'get ListView selected cell size and location
   IF topRow <= currentRow THEN 'show
      ListView_GetSubItemRect hListview1, currentRow-topRow, currentCol-1, %LVIR_Label, VARPTR(rc)
   END IF 
   CONTROL NORMALIZE hListview1, idCtrl(currentCol)
   CONTROL SET SIZE hListview1, idCtrl(currentCol), (rc.nRight-rc.nLeft), (rc.nBottom-rc.nTop)
   CONTROL SET LOC hListview1, idCtrl(currentCol), rc.nLeft, rc.nTop
   CONTROL SET FOCUS hListview1, idCtrl(currentCol)  'keep focus on textbox, off of listview
   if currentCol = 8 then
      LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, 8 TO s
      IF LEFT$(s, 3) = "P/U" THEN                                                                      
         k = 2: pickupTxt = MID$(s, 5): adStatus(2) = s
         COMBOBOX SET TEXT hListview1, %IDC_Combobox3, 2, adStatus(2)
         CONTROL NORMALIZE hMain, %IDC_Pickup                                      
         ARRAY SCAN pickup(), = pickupTxt, TO pickup0
         LISTBOX SELECT hMain, %IDC_Pickup, pickup0
      ELSE                                                                              
         ARRAY SCAN adStatus(), = s, TO k
      END IF
      COMBOBOX SELECT hListview1, %IDC_Combobox3, k
      setFocus hCombobox3: lastText = s
   end if 
   if idCtrl(currentCol) = %IDC_Textbox1 then
      IF currentCol = 5 THEN showTxtCaret1(0) ELSE showTxtCaret1(1)
   end if 
END SUB

SUB scrolledText()
   LOCAL k AS LONG
   LOCAL s AS STRING
   LISTVIEW GET TEXT hMain, %IDC_Listview1, currentRow-topRow+1, currentCol TO cellText
   IF currentCol = 2 THEN
      ARRAY SCAN salesPeople1(), = cellText, TO k
      COMBOBOX SELECT hListview1, %IDC_Combobox1, k
   ELSEIF currentCol = 4 THEN
      ARRAY SCAN adSizes(), = cellText, TO k
      COMBOBOX SELECT hListview1, %IDC_Combobox2, k                        
   ELSEIF currentCol = 8 THEN
      ARRAY SCAN adStatus(), = cellText, TO k
      IF LEN(cellText) AND k = 0 THEN
         k = 2: s = MID$(cellText, 5)
         ARRAY SCAN pickup(), = s, TO pickup0
         LISTBOX SELECT hMain, %IDC_Pickup, pickup0
      END IF
      COMBOBOX SELECT hListview1, %IDC_Combobox3, k
   ELSE
      CONTROL SET TEXT hListview1, %IDC_TextBox1, cellText
   END IF
END SUB

SUB listAdSales()
   'this routine is called after changing publication or month
   LOCAL i, n AS LONG

   'first, update dataStor for current cell
   IF numRows THEN updateCell()

   'then set the table from dataStor afterwards
   LISTVIEW RESET hMain, %IDC_Listview1
   FOR i = 1 TO maxRows
      IF LEN(stor(tabNo + 1, i)) THEN INCR n: index(n) = i
   NEXT i
   numRows = n
   setAds()
END SUB

SUB updateCell()
'update the last cell and its dependent cells
   LOCAL k, j, n, storeTheData, dataChangedSav AS LONG
   LOCAL s, ss, sItem, colr, sSize, sale, sComm AS STRING
   'first, get contents of floating text box now
   'note, contents for floating combobox retrieved in subclassListview1
   IF lastCol <> 2 AND lastCol <> 4 AND lastCol <> 8 THEN
      CONTROL GET TEXT hListview1, %IDC_TextBox1 TO cellText
   END IF
   IF tabNo <> lastTab or monthNo <> lastMonth then exit sub
   if cellText = lastText then exit sub
   'check if contents of floating cell box differs now from when it was entered
   dataChangedSav = dataChanged
   IF cellText <> lastText THEN dataChanged = 1: storeTheData = 1
   sItem = cellText
   LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, lastCol, sItem
   IF storeTheData THEN storData(lastRow, lastCol, sItem)
   LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 2 TO s
   ARRAY SCAN salesPeople1(), = s, TO choice2                                                   
   IF choice2 AND choice2 <= numSalesPeople THEN pct = pctComm(choice2) ELSE pct = ""
   IF lastCol = 4 AND choice4 THEN 'color of ad changed
      LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 5, "c"
      IF storeTheData THEN storData(lastRow, 5, "c")
   END IF
   LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 6 TO sale
   LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 9 TO sComm
   LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 3 TO sold
   LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 4 TO sSize                
   IF VAL(sold) and len(sSize) THEN 'compute cells
      ARRAY SCAN adSizes(), = sSize, TO j
      k = (tabNo-1) * numAdSizes + j
      LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 5 TO colr
      LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 8 TO ss
      IF LEN(colr) THEN s = colAds(k) ELSE s = BWAds(k)
      if lastCol = 9 then
         LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 9 TO s
         sComm = FORMAT$(VAL(s), "#.00")
      elseIF lastCol = 6 THEN
         LISTVIEW GET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 6 TO s
         sale = FORMAT$(VAL(s), "#.00")
      ELSEif lastCol >= 3 and lastCol <= 5 then
         sale = FORMAT$(VAL(sold)*VAL(s), "#.00")
      END IF 
      if len(pct) and lastCol <= 6 then
         sComm = FORMAT$(VAL(sale)*VAL(pct)/100, "#.00")
      end if
      IF lastCol = 6 AND (VAL(lastText) <> VAL(sale)) or _
         lastCol = 9 and (val(lastText) <> val(sComm)) then
         s = "This is a computed value, do you want to override it?"
         n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Caution")
         IF n = %IDNO THEN 
            listview set text hMain, %IDC_Listview1, lastRow-topRow+1, lastCol, lastText
            dataChanged = dataChangedSav: exit sub
         end if
      END IF
      LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 6, sale
      LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 8, ss
      LISTVIEW SET TEXT hMain, %IDC_Listview1, lastRow-topRow+1, 9, sComm
      IF storeTheData THEN storData(lastRow, 6, sale)
      IF storeTheData THEN storData(lastRow, 8, ss)
      IF storeTheData THEN storData(lastRow, 9, sComm)
   END IF
   choice2 = 0: choice4 = 0: choice8 = 0
END SUB

SUB setAds()
   'called after configuring ads, or changing tabs or months
   LOCAL i, j, k, m AS LONG
   LOCAL s AS STRING
   LISTVIEW RESET hMain, %IDC_Listview1
   m = IIF(tabNo = 1, monthNo, 12+tabNo-1)
   IF maxRows <> savedMaxRows THEN
      REDIM PRESERVE dataStor(1 TO 15, 1 TO 10, 1 TO maxRows)
   END IF
   FOR i = 1 TO numRows
      k = index(i)
      LISTVIEW INSERT ITEM hMain, %IDC_Listview1, i-topRow+1, 0, stor(1, k)
      FOR j = 2 TO 10
         s = dataStor(m, j, k)
         LISTVIEW SET TEXT hMain, %IDC_Listview1, i-topRow+1, j, s
      NEXT j
   NEXT i
END SUB

SUB storData(i AS LONG, j AS LONG, s AS STRING)
   'i = row number, j = column (1 to 10)
   LOCAL m AS LONG
   m = IIF(tabNo = 1 AND monthNo <= 12, monthNo, 12+tabNo-1)
   dataStor(m, j, index(i)) = s
   dataChanged = 1
END SUB

SUB scrollView1()
   'used when scrolling is required
   'note that column 1 is treated separately for ad names
   LOCAL i, j, k, m, n AS LONG
   n = MIN(numRows, numView)
   FOR i = 1 TO n
      k = index(topRow + i - 1)
      LISTVIEW SET TEXT hMain, %IDC_Listview1, i, 1, stor(1, k)
   NEXT i
   m = IIF(tabNo = 1, monthNo, 12+tabNo-1)
   FOR j = 2 TO 10
   FOR i = 1 TO n
      k = index(topRow + i - 1)
      LISTVIEW SET TEXT hMain, %IDC_Listview1, i, j, dataStor(m, j, k)
   NEXT i
   NEXT j
END SUB

SUB CreateTextbox1()
   'create textbox for selecting items in Listview
   LOCAL nStyle AS LONG
   IF hTextbox1 THEN CONTROL KILL hListview1, %IDC_Textbox1
   nStyle = %WS_TABSTOP OR %WS_BORDER OR %ES_LEFT OR  %ES_AUTOHSCROLL
   CONTROL ADD TEXTBOX, hListview1, %IDC_Textbox1, "", 0, 0, 0, 0, nStyle, %WS_EX_WINDOWEDGE
   CONTROL HANDLE hListview1, %IDC_TextBox1 TO hTextBox1
   CONTROL SET FONT hListView1, %IDC_TextBox1, hFont
   gOrigTextbox1 = SetWindowLong(hTextBox1, %GWL_WndProc, CODEPTR(subclassTextbox1))
END SUB

SUB CreateCombobox1()
   LOCAL i, nStyle AS LONG
   nStyle = %CBS_DROPDOWNLIST OR %WS_BORDER
   CONTROL ADD COMBOBOX,  hListview1, %IDC_Combobox1, salesPeople1(), 0, 0, 0, 0, nStyle, %WS_EX_WINDOWEDGE
   CONTROL HANDLE hListview1, %IDC_Combobox1 TO hComboBox1
   CONTROL SET FONT hListview1, %IDC_Combobox1, hFont2
   gOrigCombobox1 = SetWindowLong(hComboBox1, %GWL_WndProc, CODEPTR(subclassCombobox1))
END SUB

SUB CreateCombobox2()
   LOCAL i, nStyle AS LONG
   nStyle = %CBS_DROPDOWNLIST OR %WS_BORDER
   CONTROL ADD COMBOBOX, hListview1, %IDC_Combobox2, adSizes(), 0, 0, 0, 0, nStyle, %WS_EX_WINDOWEDGE
   CONTROL HANDLE hListview1, %IDC_Combobox2 TO hComboBox2
   CONTROL SET FONT hListview1, %IDC_Combobox2, hFont2
   gOrigCombobox2 = SetWindowLong(hComboBox2, %GWL_WndProc, CODEPTR(subclassCombobox1))
END SUB

SUB CreateCombobox3()
   LOCAL i, nStyle AS LONG
   nStyle = %CBS_DROPDOWNLIST OR %WS_BORDER
   CONTROL ADD COMBOBOX, hListview1, %IDC_Combobox3, adStatus(), 0, 0, 0, 0, nStyle, %WS_EX_WINDOWEDGE
   CONTROL HANDLE hListview1, %IDC_Combobox3 TO hComboBox3
   CONTROL SET FONT hListview1, %IDC_Combobox3, hFont2
   gOrigCombobox3 = SetWindowLong(hComboBox3, %GWL_WndProc, CODEPTR(subclassCombobox1))
END SUB

SUB showTxtCaret1(n AS LONG)
   setFocus hListview1
   setFocus hTextbox1
   showCaret(hTextbox1)
   IF n = 0 THEN hideCaret(hTextbox1)
END SUB

SUB Advances()
   LOCAL i, nStyle AS LONG
   LOCAL s AS STRING
   DIALOG NEW hMain, "Advances", , , 200, 220, %WS_SYSMENU TO hAdv
   control add label, hAdv, -1, "Sales people:", 5, 12, 45, 12
   nStyle = %CBS_DROPDOWNLIST OR %WS_VSCROLL OR %CBS_HASSTRINGS OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hAdv, %IDC_AdvCombo, salesPeople(), 53, 10, 100, 45, nStyle
'   if numSalespeople then COMBOBOX SELECT hAdv, %IDC_AdvCombo, 1
   s = "    Date            Advanced          Paid         Balance"
   CONTROL ADD LABEL, hAdv, -1, s, 5, 30, 180, 10
   nStyle = %WS_VSCROLL + %LBS_DISABLENOSCROLL + %WS_TABSTOP + %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hAdv, %IDC_AdvList, , 5, 40, 180, 120, nStyle
   CONTROL ADD BUTTON, hAdv, %IDC_AdvAdd, "Add entry",5, 170, 40, 18
   CONTROL ADD BUTTON, hAdv, %IDC_AdvEdt, "Edit entry",47, 170, 40, 18
   CONTROL ADD BUTTON, hAdv, %IDC_AdvDel, "Del entry",89, 170, 40, 18
   CONTROL ADD BUTTON, hAdv, %IDC_AdvClr, "&Clear",150, 170, 40, 18
   DIALOG SHOW MODAL hAdv, CALL advancesProc
END SUB

CALLBACK FUNCTION advancesProc() 
   LOCAL i, j, m, n, hFont AS LONG
   local arrOrder() as long
   LOCAL s1, s2, s3 AS STRING
   LOCAL s AS WSTRING
   LOCAL lptr AS LONG PTR
   STATIC task, entryNo, salesPerson AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         FONT NEW "Courier New", 9, 1 TO hFont
         CONTROL SET FONT CB.HNDL, %IDC_AdvList, hFont
         DIM tabstops(3) AS LONG
         tabstops(0) = 0     'column 1
         tabstops(1) = 52    'column 2
         tabstops(2) = 94    'column 3
         tabstops(3) = 136   'column 4
         lptr = VARPTR(tabstops(0))
         CONTROL SEND CB.HNDL, %IDC_AdvList, %LB_SETTABSTOPS, 4, lptr
         DIALOG POST CB.HNDL,%WM_USER+500, 0, 0
      CASE %WM_USER+500 'show dialog for first time
         CONTROL SET FOCUS CB.HNDL, %IDC_AdvList
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDOK 'submit added or edited record
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_SubmitBtn, 0
            CASE %IDC_AdvCombo
               IF CB.CTLMSG = %CBN_SETFOCUS THEN
                  LISTBOX UNSELECT CB.HNDL, %IDC_AdvList
               ELSEIF CB.CTLMSG = %CBN_SELCHANGE THEN
                  COMBOBOX GET SELECT CB.HNDL, CB.CTL TO n
                  numAdvEntries = 0: salesPerson = n
                  IF n = 1 AND numAdvEntries1 THEN
                     numAdvEntries = numAdvEntries1
                     REDIM arrDate(1 TO numAdvEntries)
                     REDIM arrAdv(1 TO numAdvEntries)
                     REDIM arrPaid(1 TO numAdvEntries)               
                     FOR i = 1 TO numAdvEntries
                        arrDate(i) = arrDate1(i)
                        arrAdv(i) = arrAdv1(i)
                        arrPaid(i) = arrPaid1(i)
                     NEXT i
                  ELSEIF n = 2 AND numAdvEntries2 THEN
                     numAdvEntries = numAdvEntries2
                     REDIM arrDate(1 TO numAdvEntries)
                     REDIM arrAdv(1 TO numAdvEntries)
                     REDIM arrPaid(1 TO numAdvEntries)
                     FOR i = 1 TO numAdvEntries
                        arrDate(i) = arrDate2(i)
                        arrAdv(i) = arrAdv2(i)
                        arrPaid(i) = arrPaid2(i)
                     NEXT i
                  END IF
                  addToAdvances 1
                  CONTROL SET FOCUS CB.HNDL, %IDC_AdvList
               END IF
            CASE %IDC_AdvList
               IF CB.CTLMSG = %LBN_SETFOCUS THEN
                  CONTROL KILL CB.HNDL, %IDC_Date
                  CONTROL KILL CB.HNDL, %IDC_Adv
                  CONTROL KILL CB.HNDL, %IDC_Paid
                  CONTROL KILL CB.HNDL, %IDC_SubmitBtn
                  CONTROL NORMALIZE CB.HNDL,%IDC_AdvAdd
                  CONTROL NORMALIZE CB.HNDL,%IDC_AdvEdt
                  CONTROL NORMALIZE CB.HNDL,%IDC_AdvDel
                  CONTROL NORMALIZE CB.HNDL,%IDC_AdvClr
                  LISTBOX GET SELECT CB.HNDL, CB.CTL TO n
                  IF n = 0 THEN LISTBOX SELECT CB.HNDL, CB.CTL, 1
               END IF
            CASE %IDC_AdvAdd, %IDC_AdvEdt
               COMBOBOX GET SELECT CB.HNDL, %IDC_AdvCombo TO j
               IF j = 0 THEN EXIT FUNCTION
               task = CB.CTL - %IDC_AdvAdd  '...0 for add, 1 for edit
               IF task THEN
                  IF numAdvEntries = 0 THEN EXIT FUNCTION
                  LISTBOX GET SELECT CB.HNDL, %IDC_AdvList TO j
                  entryNo = numAdvEntries - j + 1
               END IF
               CONTROL HIDE CB.HNDL, %IDC_AdvAdd
               CONTROL HIDE CB.HNDL, %IDC_AdvEdt
               CONTROL HIDE CB.HNDL, %IDC_AdvDel
               CONTROL HIDE CB.HNDL, %IDC_AdvClr
               CONTROL ADD TEXTBOX, CB.HNDL, %IDC_Date, "", 5, 180, 45, 11
               CONTROL ADD TEXTBOX, CB.HNDL, %IDC_Adv, "", 50, 180, 45, 11
               CONTROL ADD TEXTBOX, CB.HNDL, %IDC_Paid, "", 95, 180, 45, 11
               CONTROL ADD BUTTON, CB.HNDL, %IDC_SubmitBtn,"Submit", 150, 177, 40,15
               CONTROL SET FONT CB.HNDL, %IDC_Date, hFont
               CONTROL SET FONT CB.HNDL, %IDC_Adv, hFont
               CONTROL SET FONT CB.HNDL, %IDC_Paid, hFont
               s = "Date": CONTROL SEND CB.HNDL, %IDC_Date, %EM_SetCueBanner, 1, STRPTR(s)
               s = "Advanced": CONTROL SEND CB.HNDL, %IDC_Adv, %EM_SetCueBanner, 1, STRPTR(s)
               s = "Paid": CONTROL SEND CB.HNDL, %IDC_Paid, %EM_SetCueBanner, 1, STRPTR(s)
               CONTROL SET FOCUS CB.HNDL, %IDC_Date
               IF task THEN 'edit entry
                  CONTROL SET TEXT CB.HNDL, %IDC_Date, arrDate(entryNo)
                  IF arrAdv(entryNo) THEN _
                     CONTROL SET TEXT CB.HNDL, %IDC_Adv, FORMAT$(arrAdv(entryNo),"#.00")
                  IF arrPaid(entryNo) THEN _
                     CONTROL SET TEXT CB.HNDL, %IDC_Paid, FORMAT$(arrPaid(entryNo),"#.00")
                  CONTROL SET TEXT CB.HNDL, %IDC_SubmitBtn, "Replace"
               END IF
            CASE %IDC_Adv 'show advance, not paid
               IF CB.CTLMSG = %EN_CHANGE THEN
                  CONTROL GET TEXT CB.HNDL, %IDC_Adv TO s
                  IF LEN(s) THEN
                     s = "": CONTROL SEND CB.HNDL, %IDC_Paid, %EM_SetCueBanner, 1, STRPTR(s)
                  ELSE
                     s = "Paid": CONTROL SEND CB.HNDL, %IDC_Paid, %EM_SetCueBanner, 1, STRPTR(s)
                  END IF
               END IF
            CASE %IDC_Paid 'show paid, not advance
               IF CB.CTLMSG = %EN_CHANGE THEN
                  CONTROL GET TEXT CB.HNDL, %IDC_Paid TO s
                  IF LEN(s) THEN
                     s = "": CONTROL SEND CB.HNDL, %IDC_Adv, %EM_SetCueBanner, 1, STRPTR(s)
                  ELSE
                     s = "Advance": CONTROL SEND CB.HNDL, %IDC_Adv, %EM_SetCueBanner, 1, STRPTR(s)
                  END IF
               END IF
            CASE %IDC_AdvDel
               IF numAdvEntries = 0 THEN EXIT FUNCTION
               LISTBOX GET SELECT CB.HNDL, %IDC_AdvList TO j
               s = "Delete this entry?"
               n = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Entry"+STR$(j))
               IF n = %IDNO THEN EXIT FUNCTION
               n = numAdvEntries - j + 1
               ARRAY DELETE arrDate(n)
               ARRAY DELETE arrAdv(n)
               ARRAY DELETE arrPaid(n)
               DECR numAdvEntries
               advDataChanged = salesPerson
               addToAdvances MIN(j, numAdvEntries)
            CASE %IDC_AdvClr
               IF numAdvEntries = 0 THEN EXIT FUNCTION
               LISTBOX GET SELECT CB.HNDL, %IDC_AdvList TO j
               s = "Delete this and all earlier entries?"
               n = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Entry"+STR$(j)+" to"+STR$(numAdvEntries))
               IF n = %IDNO THEN EXIT FUNCTION
               n = numAdvEntries - j + 1
               FOR i = 1 TO n
                  ARRAY DELETE arrDate(1)
                  ARRAY DELETE arrAdv(1)
                  ARRAY DELETE arrPaid(1)
                  DECR numAdvEntries
               NEXT i
               advDataChanged = salesPerson
               addToAdvances numAdvEntries
            CASE %IDC_SubmitBtn  'add or replace entry
               CONTROL GET TEXT CB.HNDL, %IDC_Date TO s1
               CONTROL GET TEXT CB.HNDL, %IDC_Adv TO s2: s2 = TRIM$(s2)
               CONTROL GET TEXT CB.HNDL, %IDC_Paid TO s3: s3 = TRIM$(s3)
               IF LEN(s1 + s2 + s3) = 0 THEN 'cannot submit blank entry
                  CONTROL SET FOCUS CB.HNDL, %IDC_AdvList
                  LISTBOX UNSELECT CB.HNDL, %IDC_AdvList
                  EXIT FUNCTION
               END IF
               n = verifyDate(s1): m = numAdvEntries
               IF n AND LEN(s2 + s3) THEN 'add the entry
                  INCR numAdvEntries
                  REDIM PRESERVE arrDate(1 TO numAdvEntries)
                  REDIM PRESERVE arrAdv(1 TO numAdvEntries)
                  REDIM PRESERVE arrPaid(1 TO numAdvEntries)
                  redim arrOrder(1 TO numAdvEntries)
                  for i = 1 to numAdvEntries
                     arrOrder(i) = verifyDate(arrDate(i))
                  next i
                  'find where to insert the added entries
                  i = numAdvEntries - 1
                  WHILE i > 0 AND arrOrder(i) > n: DECR i: WEND: INCR i
                  ARRAY INSERT arrDate(i), s1
                  ARRAY INSERT arrAdv(i), VAL(s2)
                  ARRAY INSERT arrPaid(i), VAL(s3)
                  IF task THEN 'now delete the selected entry
                     IF i < entryNo THEN INCR entryNo
                     ARRAY DELETE arrDate(entryNo)
                     ARRAY DELETE arrAdv(entryNo)
                     ARRAY DELETE arrPaid(entryNo)
                     DECR numAdvEntries
                  END IF
                  advDataChanged = salesPerson
                  addToAdvances numAdvEntries - entryNo + 1
               ELSE
                  IF n = 0 THEN
                     MSGBOX "Date error... correct and continue", %MB_ICONERROR, "ERROR"
                  ELSEIF LEN(s2 + s3) = 0 THEN
                     MSGBOX "Must enter an advance or paid amount", %MB_ICONERROR, "ERROR"
                  END IF
                  numAdvEntries = m
                  EXIT FUNCTION
               END IF
               CONTROL SET FOCUS CB.HNDL, %IDC_AdvList
         END SELECT
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            dataChanged = advDataChanged
         END IF
   END SELECT
END FUNCTION

SUB addToAdvances(iSel AS LONG)
   'selected entry - iSel
   LOCAL i AS LONG
   LOCAL s, s1, s2, s3 AS STRING
   LISTBOX RESET hAdv, %IDC_AdvList
   IF numAdvEntries = 0 THEN EXIT SUB
   REDIM arrBal(1 TO numAdvEntries) AS DOUBLE                                     
   FOR i = 1 TO numAdvEntries
      arrBal(i) = arrBal(i-1) + arrAdv(i) - arrPaid(i)
   NEXT i
   FOR i = numAdvEntries TO 1 STEP -1
      IF arrAdv(i) THEN s1 = FORMAT$(arrAdv(i), "#.00") ELSE s1 = ""
      IF arrPaid(i) THEN s2 = FORMAT$(arrPaid(i), "#.00") ELSE s2 = ""
      s3 = FORMAT$(arrBal(i), "#.00")
      s = arrDate(i)+$TAB+RSET$(s1, 8)+$TAB+RSET$(s2, 8)+$TAB+RSET$(s3, 8)
      LISTBOX ADD hAdv, %IDC_AdvList, s
   NEXT i
   IF advDataChanged = 1 THEN 'sales person 1
      numAdvEntries1 = numAdvEntries
      REDIM arrDate1(1 TO numAdvEntries)
      REDIM arrAdv1(1 TO numAdvEntries)
      REDIM arrPaid1(1 TO numAdvEntries)
      FOR i = 1 TO numAdvEntries
         arrDate1(i) = arrDate(i)
         arrAdv1(i) = arrAdv(i)
         arrPaid1(i) = arrPaid(i)
      NEXT i
   ELSEIF advDataChanged = 2 THEN 'sales person 2
      numAdvEntries2 = numAdvEntries
      REDIM arrDate2(1 TO numAdvEntries)
      REDIM arrAdv2(1 TO numAdvEntries)
      REDIM arrPaid2(1 TO numAdvEntries)
      FOR i = 1 TO numAdvEntries
         arrDate2(i) = arrDate(i)
         arrAdv2(i) = arrAdv(i)
         arrPaid2(i) = arrPaid(i)
      NEXT i
   END IF
   LISTBOX SELECT hAdv, %IDC_AdvList, iSel
   CONTROL SET FOCUS hAdv, %IDC_AdvList
END SUB

FUNCTION verifyDate(ss AS STRING) AS LONG
   'if a valid date, the full date is returned in ss
   'if not a valid date, the original date is returned in ss
   'the functional value is returned as a long value for sorting
   'the sorting value corresponding to 08/24/2017 is 20170824
   '------------------------------------------------------------------
   LOCAL n, m, d, y, nErr AS LONG
   LOCAL s, mo, day, yr AS STRING
   s = ss
   n = PARSECOUNT(s, ANY "-/")
   IF n = 0 THEN s = DATE$
   IF n = 2 THEN s = s + "/" + MID$(DATE$, 7)

   m = VAL(PARSE$(s, ANY "-/", 1))
   d = VAL(PARSE$(s, ANY "-/", 2))
   y = VAL(PARSE$(s, ANY "-/", 3))
   IF y < 100 THEN y = 2000 + y
   IF y < 2000 AND y > 99 THEN nErr = 1
   IF m < 1 OR m > 12 THEN nErr = 1
   IF d < 1 OR d > daysInMonth(m, y) THEN nErr = 1
   IF nErr THEN FUNCTION = 0: EXIT FUNCTION

   mo = RIGHT$("0" + TRIM$(STR$(m)), 2)
   day = RIGHT$("0" + TRIM$(STR$(d)), 2)
   yr = TRIM$(STR$(y))
   ss = mo + "/" + day + "/" + yr
   FUNCTION = VAL(yr + mo + day)
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

SUB PrintRunSheet()
   LOCAL i, j, ii, xppi, yppi, hFont1, hFont2 AS LONG
   LOCAL x, y, xc, yc, yyc AS SINGLE
   LOCAL s, sHeader AS STRING
   IF tabNo = 1 AND monthNo THEN s = months(monthNo) ELSE s = mag(tabNo)
   XPRINT ATTACH CHOOSE
   IF LEN(XPRINT$) = 0 THEN EXIT SUB
   FONT NEW "Times New Roman", 10, 5 TO hFont1
   FONT NEW "Times New Roman", 10 TO hFont2
   XPRINT SPACE$(8) + "BBToday Run Sheet for " + s + " Magazine - " + RIGHT$(DATE$, 4)
   XPRINT SET FONT hFont1
   XPRINT GET PPI TO xppi, yppi
   XPRINT CHR SIZE TO xc, yc
   yyc = 1.5 * yc
   y = 2.5* yyc
   XPRINT SET POS (1.00*xppi, y)
   XPRINT "Sold Ads"
   XPRINT SET POS (3.00*xppi, y)
   XPRINT "Status"
   XPRINT SET FONT hFont2
   FOR i = 1 TO maxRows
      LISTVIEW GET TEXT hMain, %IDC_Listview1, i, 3 TO s
      IF VAL(s) THEN
         INCR ii: y = yyc*(3 + ii)
         LISTVIEW GET TEXT hMain, %IDC_Listview1, i, 1 TO s
         x = 1.00 * xppi
         XPRINT SET POS (x, y): XPRINT s
         LISTVIEW GET TEXT hMain, %IDC_Listview1, i, 8 TO s
         x = 3.00 * xppi
         XPRINT SET POS (x, y): XPRINT s
      END IF
   NEXT i
   XPRINT CLOSE
   FONT END hFont1
END SUB

SUB report()
'numSalesPeople = 2
   LOCAL n, nStyle AS LONG
   LOCAL salesPerson1, salesPerson2 AS STRING
   nStyle = %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Year to date reporting", , , 630, 470, nStyle TO hReport
   nStyle = %LVS_REPORT OR %LVS_NOSCROLL OR %WS_VISIBLE OR %LVS_SHOWSELALWAYS
   CONTROL ADD LISTVIEW, hReport, %IDC_LVreport, "", 10, 25, 605, 370, nStyle, %WS_EX_CLIENTEDGE
   LISTVIEW SET STYLEXX hReport, %IDC_LVreport, %LVS_EX_GRIDLINES OR %LVS_EX_FULLROWSELECT
   IF numSalesPeople = 1 THEN salesPerson1 = salesPeople(1) ELSE salesPerson1 = "salesPerson1"
   IF numSalesPeople = 2 THEN salesPerson2 = salesPeople(2) ELSE salesPerson2 = "salesPerson2"
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 1, "Publication", 150, 0
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 2, "", 90, 1
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 3, "", 90, 1
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 4, "", 90, 1
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 5, "", 90, 1
   LISTVIEW INSERT COLUMN hReport, %IDC_LVreport, 6, "Paid Sales", 90, 1
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 1,  0, "January"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 2,  0, "February"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 3,  0, "March"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 4,  0, "April"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 5,  0, "May"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 6,  0, "June"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 7,  0, "July"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 8,  0, "August"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 9,  0, "September"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 10, 0, "October"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 11, 0, "November"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 12, 0, "December"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 13, 0, ""
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 14, 0, "Monthly Magazine"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 15, 0, "Ski Magazine"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 16, 0, "Summer Magazine"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 17, 0, "OctFest Magazine"
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 18, 0, ""
   LISTVIEW INSERT ITEM hReport, %IDC_LVreport, 19, 0, "      Totals"
   CONTROL ADD LABEL, hReport, %IDC_salesPerson1, salesPerson1, 160, 10, 180, 16, %SS_CENTER
   CONTROL ADD LABEL, hReport, %IDC_salesPerson2, salesPerson2, 340, 10, 180, 16, %SS_CENTER
   CONTROL ADD BUTTON, hReport, %IDC_PrnReport, "&Print", 100, 410, 90, 40
   CONTROL ADD BUTTON, hReport, %IDC_Close, "&Close", 200, 410, 90, 40
   CONTROL ADD OPTION, hReport, %IDC_Report1, "Total Sales", 400, 415, 100, 12
   CONTROL ADD OPTION, hReport, %IDC_Report2, "Commissions", 400, 435, 100, 12
   CONTROL SET OPTION hReport, %IDC_Report1, %IDC_Report1,%IDC_Report2
   DIALOG SHOW MODAL hReport CALL reportProc()
END SUB

CALLBACK FUNCTION reportProc()
   LOCAL n AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         reportSales()
         'reportCommissions()
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDC_Report1, %IDC_Report2
               CONTROL GET CHECK CB.HNDL, %IDC_Report1 TO n
               IF n THEN reportSales() ELSE reportCommissions
            CASE %IDC_PrnReport
               prnReport()
            CASE %IDC_Close
               DIALOG END CB.HNDL
         END SELECT
   END SELECT
END FUNCTION

SUB reportSales()
   LOCAL i, j, k, m, n AS LONG
   LOCAL q0, q1, q2, qq0, qq1, qq2, pp0 AS DOUBLE
   LOCAL qComm1, qComm2, qqComm1, qqComm2 AS DOUBLE
   LOCAL u0, u1, u2 AS DOUBLE
   LOCAL v0, v1, v2 AS DOUBLE
   LOCAL w0, w1, w2 AS DOUBLE
   LOCAL grandTotalSales, grandPaidSales, moTotalSales, moPaidSales AS DOUBLE
   LOCAL totalSales(), paidSales() AS DOUBLE
   LOCAL s, salesPerson1, salesPerson2 AS STRING
   CONTROL HIDE hReport, %IDC_SalesPerson1
   CONTROL HIDE hReport, %IDC_SalesPerson2
   IF numSalesPeople = 1 THEN salesPerson1 = salesPeople(1) ELSE salesPerson1 = "salesPerson1"
   IF numSalesPeople = 2 THEN salesPerson2 = salesPeople(2) ELSE salesPerson2 = "salesPerson2"
   DIALOG SET CLIENT hReport, 630, 460
   CONTROL SET SIZE hReport, %IDC_LVreport, 605, 365
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 2, "Owner"
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 3, salesPerson1
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 4, salesPerson2
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 5, "Total Sales "
   LISTVIEW SET COLUMN hReport, %IDC_LVreport, 6, 90  'resetting last column
   REDIM totalSales(1 TO 15)
   REDIM paidSales(1 TO 15)
   'sum sales for owner and each sales person
   qq0 = 0: qq1 = 0: qq2 = 0: qqComm1 = 0: qqComm2 = 0
   FOR k = 1 TO numSalesPeople + 1
   FOR m = 1 TO 15
      q0 = 0: q1 = 0: q2 = 0: 'monthly
      u0 = 0: u1 = 0: u2 = 0  'ski
      v0 = 0: v1 = 0: v2 = 0  'summer
      w0 = 0: w1 = 0: w2 = 0  'octFest
      FOR i = 1 TO maxRows
         IF k = numSalesPeople + 1 THEN 'sum totalSales just once
            totalSales(m) += VAL(dataStor(m, 6, i))
            paidSales(m) += VAL(dataStor(m, 7, i))
         END IF
         IF k = numSalesPeople + 1 AND dataStor(m, 2, i) = "Owner" THEN
            IF m <= 12 THEN q0 += VAL(dataStor(m, 6, i))
            IF m = 13 THEN u0 += VAL(dataStor(m, 6, i))
            IF m = 14 THEN v0 += VAL(dataStor(m, 6, i))
            IF m = 15 THEN w0 += VAL(dataStor(m, 6, i))
         ELSEIF k = 1 AND dataStor(m, 2, i) = salesPerson1 THEN  'salesPeople1(1) then
            IF m <= 12 THEN q1 += VAL(dataStor(m, 6, i))
            IF m = 13 THEN u1 += VAL(dataStor(m, 6, i))
            IF m = 14 THEN v1 += VAL(dataStor(m, 6, i))
            IF m = 15 THEN w1 += VAL(dataStor(m, 6, i))
         ELSEIF k = 2 AND dataStor(m, 2, i) = salesPerson2 THEN  'salesPeople1(2) then
            IF m <= 12 THEN q2 += VAL(dataStor(m, 6, i))
            IF m = 13 THEN u2 += VAL(dataStor(m, 6, i))
            IF m = 14 THEN v2 += VAL(dataStor(m, 6, i))
            IF m = 15 THEN w2 += VAL(dataStor(m, 6, i))
         END IF
      NEXT i
      'show the total sales for owner and each salesPerson
      IF k = numSalesPeople + 1 THEN
         qq0 = qq0 + q0
         IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 2, FORMAT$(q0, "#.00")
         IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 2, FORMAT$(u0, "#.00")
         IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 2, FORMAT$(v0, "#.00")
         IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 2, FORMAT$(w0, "#.00")
      ELSEIF k = 1 THEN
         qq1 = qq1 + q1
         IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 3, FORMAT$(q1, "#.00")
         IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 3, FORMAT$(u1, "#.00")
         IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 3, FORMAT$(v1, "#.00")
         IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 3, FORMAT$(w1, "#.00")
      ELSEIF k = 2 THEN
         qq2 = qq2 + q2
         IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 4, FORMAT$(q2, "#.00")
         IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 4, FORMAT$(u2, "#.00")
         IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 4, FORMAT$(v2, "#.00")
         IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 4, FORMAT$(w2, "#.00")
      END IF
   NEXT m
      'show yearly totals for owner and each salesperson on Monthly Magazine row
      IF k = numSalesPeople + 1 THEN 'owner
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 2, FORMAT$(qq0, "#.00")
      ELSEIF k = 1 THEN
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 3, FORMAT$(qq1, "#.00")
      ELSE
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 4, FORMAT$(qq2, "#.00")
      END IF
   NEXT k
   'show grand total sales for owner and sales people on last line -------------------------------
   qq0 = 0: qq1 = 0: qq2 = 0: pp0 = 0
   FOR i = 14 TO 17
      LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 2 TO s: qq0 = qq0 + VAL(s)
      IF numSalesPeople = 1 THEN
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 3 TO s: qq1 = qq1 + VAL(s)
      END IF
      IF numSalesPeople = 2 THEN
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 5 TO s: qq2 = qq2 + VAL(s)
      END IF
   NEXT i
   LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 2, FORMAT$(qq0, "#.00")
   IF numSalesPeople THEN
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 3, FORMAT$(qq1, "#.00")
   END IF
   IF numSalesPeople = 2 THEN
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 4, FORMAT$(qq2, "#.00")
   END IF
   'show total sales plus grand total in last column ----------------------------------
   FOR i = 1 TO 12 'first, the monthly totals
      moTotalSales += totalSales(i)
      moPaidSales += paidSales(i)
      LISTVIEW SET TEXT hReport, %IDC_LVreport, i, 5, FORMAT$(totalSales(i), "#.00")
      LISTVIEW SET TEXT hReport, %IDC_LVreport, i, 6, FORMAT$(paidSales(i), "#.00")
   NEXT i
   grandTotalSales = moTotalSales
   grandPaidSales = moPaidSales
   FOR i = 15 TO 17 'ski, summer, octFest
      LISTVIEW SET TEXT hReport, %IDC_LVreport, i, 5, FORMAT$(totalSales(i-2), "#.00")
      LISTVIEW SET TEXT hReport, %IDC_LVreport, i, 6, FORMAT$(paidSales(i-2), "#.00")
      grandTotalSales += totalSales(i-2)
      grandPaidSales += paidSales(i-2)
   NEXT i
   LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 5, FORMAT$(moTotalSales, "#.00")
   LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 6, FORMAT$(moPaidSales, "#.00")
   LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 5, FORMAT$(grandTotalSales, "#.00")
   LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 6, FORMAT$(grandPaidSales, "#.00")
END SUB
                                                                                      
SUB reportCommissions()
   LOCAL i, j, k, m, n AS LONG
   LOCAL qqComm1, qqComm2, qqpComm1, qqpComm2 AS DOUBLE
   LOCAL qpComm1, qpComm2, upComm1, upComm2, vpComm1, vpComm2, wpComm1, wpComm2 AS DOUBLE
   LOCAL qComm1, qComm2, uComm1, uComm2, vComm1, vComm2, wComm1, wComm2 AS DOUBLE
   LOCAL s, salesPerson1, salesPerson2 AS STRING
   IF numSalesPeople = 1 THEN salesPerson1 = salesPeople(1) ELSE salesPerson1 = "salesPerson1"
   IF numSalesPeople = 2 THEN salesPerson2 = salesPeople(2) ELSE salesPerson2 = "salesPerson2"
   DIALOG SET CLIENT hReport, 540, 460
   CONTROL SET SIZE hReport, %IDC_LVreport, 515, 365
   CONTROL NORMALIZE hReport, %IDC_SalesPerson1
   CONTROL NORMALIZE hReport, %IDC_SalesPerson2
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 2, "Commission1"
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 3, "Comm1 Paid"
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 4, "Commission2"
   LISTVIEW SET HEADER hReport, %IDC_LVreport, 5, "Comm2 Paid"
   LISTVIEW SET COLUMN hReport, %IDC_LVreport, 6, 0  'removing last column
   FOR i = 1 TO 19  'clear all cells
      FOR j = 2 TO 5
         LISTVIEW SET TEXT hReport, %IDC_LVreport, i, j, ""
      NEXT j
   NEXT i
   FOR k = 1 TO numSalesPeople
      'sum for commissions for each sales person with their paid amounts
      qqComm1 = 0: qqComm2 = 0
      FOR m = 1 TO 15
         qComm1 = 0: qComm2 = 0: qpComm1 = 0: qpComm2 = 0  'monthly
         uComm1 = 0: uComm2 = 0: upComm1 = 0: upComm2 = 0  'ski
         vComm1 = 0: vComm2 = 0: vpComm1 = 0: vpComm2 = 0  'summer
         wComm1 = 0: wComm2 = 0: wpComm1 = 0: wpComm2 = 0  'octFest
         FOR i = 1 TO maxRows
            IF k = 1 AND dataStor(m, 2, i) = salesPerson1 THEN
               IF m <= 12 THEN qComm1 += VAL(dataStor(m, 9, i))
               IF m <= 12 THEN qpComm1 += VAL(dataStor(m, 10, i))
               IF m = 13 THEN uComm1 += VAL(dataStor(m, 9, i))
               IF m = 13 THEN upComm1 += VAL(dataStor(m, 10, i))
               IF m = 14 THEN vComm1 += VAL(dataStor(m, 9, i))
               IF m = 14 THEN vpComm1 += VAL(dataStor(m, 10, i))
               IF m = 15 THEN wComm1 += VAL(dataStor(m, 9, i))
               IF m = 15 THEN wpComm1 += VAL(dataStor(m, 10, i))
            ELSEIF k = 2 AND dataStor(m, 2, i) = salesPerson2 THEN
               IF m <= 12 THEN qComm2 += VAL(dataStor(m, 9, i))
               IF m <= 12 THEN qpComm2 += VAL(dataStor(m, 10, i))
               IF m = 13 THEN uComm2 += VAL(dataStor(m, 9, i))
               IF m = 13 THEN upComm2 += VAL(dataStor(m, 10, i))
               IF m = 14 THEN vComm2 += VAL(dataStor(m, 9, i))
               IF m = 14 THEN vpComm2 += VAL(dataStor(m, 10, i))
               IF m = 15 THEN wComm2 += VAL(dataStor(m, 9, i))
               IF m = 15 THEN wpComm2 += VAL(dataStor(m, 10, i))
            END IF
         NEXT i
         'show total commissions and amounts paid
         IF k = 1 THEN
            qqComm1 += qComm1
            qqpComm1 += qpComm1
            IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 2, FORMAT$(qComm1, "#.00")
            IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 3, FORMAT$(qpComm1, "#.00")
            IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 2, FORMAT$(uComm1, "#.00")
            IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 3, FORMAT$(upComm1, "#.00")
            IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 2, FORMAT$(vComm1, "#.00")
            IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 3, FORMAT$(vpComm1, "#.00")
            IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 2, FORMAT$(wComm1, "#.00")
            IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 3, FORMAT$(wpComm1, "#.00")
         ELSEIF k = 2 THEN
            qqComm2 += qComm2
            qqpComm2 += qpComm2
            IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 4, FORMAT$(qComm2, "#.00")
            IF m <= 12 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, m, 5, FORMAT$(qpComm2, "#.00")
            IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 4, FORMAT$(uComm2, "#.00")
            IF m = 13 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 15, 5, FORMAT$(upComm2, "#.00")
            IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 4, FORMAT$(vComm2, "#.00")
            IF m = 14 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 16, 5, FORMAT$(vpComm2, "#.00")
            IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 4, FORMAT$(wComm2, "#.00")
            IF m = 15 THEN LISTVIEW SET TEXT hReport, %IDC_LVreport, 17, 5, FORMAT$(wpComm2, "#.00")
         END IF
      NEXT m
      'show yearly totals on monthly magazine row
      IF k = 1 THEN
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 2, FORMAT$(qqComm1, "#.00")
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 3, FORMAT$(qqpComm1, "#.00")
      ELSE
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 4, FORMAT$(qqComm2, "#.00")
         LISTVIEW SET TEXT hReport, %IDC_LVreport, 14, 5, FORMAT$(qqpComm2, "#.00")
      END IF
   NEXT k
   'show grand totals on last line
   qqComm1 = 0: qqComm2 = 0: qqpComm1 = 0: qqpComm2 = 0
   FOR i = 14 TO 17 'record totals on last line
      IF numSalesPeople = 1 THEN
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 2 TO s: qqComm1 += VAL(s)
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 3 TO s: qqpComm1 += VAL(s)
      END IF
      IF numSalesPeople = 2 THEN
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 4 TO s: qqComm2 += VAL(s)
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, 5 TO s: qqpComm2 += VAL(s)
      END IF
   NEXT i
   IF numSalesPeople = 1 THEN
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 2, FORMAT$(qqComm1, "#.00")
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 3, FORMAT$(qqpComm1, "#.00")
   END IF
   IF numSalesPeople = 2 THEN
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 4, FORMAT$(qqComm2, "#.00")
      LISTVIEW SET TEXT hReport, %IDC_LVreport, 19, 5, FORMAT$(qqpComm2, "#.00")
   END IF
END SUB

SUB prnReport()
   LOCAL i, j, k, n, xppi, yppi, hFont, hFont1, hFont2 AS LONG
   LOCAL x, y, xc, yc, yyc AS SINGLE
   LOCAL colPos() AS SINGLE
   LOCAL s AS STRING
   DIM colPos(1 TO 10)
   XPRINT ATTACH CHOOSE
   IF LEN(XPRINT$) = 0 THEN EXIT SUB
   FONT NEW "Times New Roman", 10, 5 TO hFont1
   FONT NEW "Times New Roman", 10 TO hFont2
   XPRINT SPACE$(20) + "BBToday Ads - Reporting for " + DATE$
   XPRINT SET FONT hFont1
   XPRINT GET PPI TO xppi, yppi
   XPRINT CHR SIZE TO xc, yc
   yyc = 1.5 * yc
   ARRAY ASSIGN colPos() =  .50, 2.00, 2.75, 3.70, 4.65, 5.60, 6.65
   y = 2.5*yyc
   n = CHOOSE(numSalesPeople+1, 3, 5, 7)
   FOR j = 1 TO n
      x = colPos(j) * xppi
      XPRINT SET POS (x, y)
      LISTVIEW GET HEADER hReport, %IDC_LVreport, j TO s
      XPRINT TRIM$(s)
   NEXT j
   FONT END hFont1
   XPRINT SET FONT hFont2
   ARRAY ASSIGN colPos() =  .50, 2.00, 2.95, 3.90, 4.85, 5.80, 6.75
   k = 19
   FOR i = 1 TO k
      y = yyc*(3 + i)
      FOR j = 1 TO n
         LISTVIEW GET TEXT hReport, %IDC_LVreport, i, j TO s
         x = colPos(j) * xppi
         XPRINT SET POS (x, y): XPRINT s
      NEXT j
   NEXT i
   XPRINT CLOSE
   FONT END hFont1
END SUB

FUNCTION whatNow() AS LONG
   'msgbox "Under construction...": exit sub
   LOCAL nStyle, hWhatNow, result AS LONG
   LOCAL s1, s2 AS STRING
   s1 = "Continue with" + STR$(storedYr) + " data"
   s2 = "Archive" + STR$(storedYr) + " data and reset for next year"
   nStyle = %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "What now?", , , 300, 180, nStyle TO hWhatNow
   CONTROL ADD OPTION, hWhatNow, %IDC_ContOpt, s1, 30, 25, 250, 20
   CONTROL ADD OPTION, hWhatNow, %IDC_ArcOpt, s2, 30, 50, 250, 20
   CONTROL SET OPTION hWhatNow, %IDC_ContOpt,  %IDC_ContOpt, %IDC_ArcOpt
   CONTROL ADD BUTTON, hWhatNow, %IDOK, "&Ok", 120, 100, 70, 35
   DIALOG SHOW MODAL hWhatNow CALL whatNowProc() TO result
   FUNCTION = result
END FUNCTION

CALLBACK FUNCTION whatNowProc()
   LOCAL result AS LONG
   SELECT CASE CB.MSG
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            CONTROL GET CHECK CB.HNDL, %IDC_ArcOpt TO result
            DIALOG END CB.HNDL, result
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN endProg = 1
   END SELECT
END FUNCTION

SUB Archive_Reset()
   'archive current dataFile and iniFile in archive folder
   'reset dataFile and iniFile in current folder
   LOCAL yr AS LONG
   LOCAL s1, s2, year, sDir, sFolder AS STRING
   sDir = "BBTodayAds_Archive\"
   sFolder = EXE.PATH$ + sDir
   IF NOT ISFOLDER(sFolder) THEN MKDIR sFolder
   yr = VAL(RIGHT$(DATE$, 4))
   year = TRIM$(STR$(yr - 1))
   s1 = sFolder + PATHNAME$(NAME, iniFile) + "_" + year + ".ini"
   s2 = sFolder + PATHNAME$(NAME, dataFile) + "_" + year + ".bbt"
   FILECOPY iniFile, s1
   FILECOPY dataFile, s2
   tabNo = 1: monthNo = 1: topRow = 1
   currentRow = 1: currentCol = 2: lastCol = 2
   REDIM dataStor(1 TO 15, 1 TO 10, 1 TO maxRows)
   initialize()
END SUB

SUB loadDataFile()
   LOCAL i, j, k, m, fileNo, unused1, unused2 AS LONG
   LOCAL sVer AS STRING
   'maxRows is read in from the iniFile
   IF maxRows = 0 THEN EXIT SUB
   fileNo = FREEFILE
   OPEN dataFile FOR INPUT AS fileNo
   INPUT #fileNo, sVer, storedYr
   storedYr = 2016
   REDIM dataStor(1 TO 15, 1 TO 10, 1 TO maxRows)
   FOR j = 1 TO 15 'load 12 months + 3 seasonal pubs
      FOR i = 1 TO maxRows
         INPUT #fileNo, dataStor(j,1,i), dataStor(j,2,i), dataStor(j,3,i), dataStor(j,4,i),_
                        dataStor(j,5,i), dataStor(j,6,i), dataStor(j,7,i), dataStor(j,8,i),_
                        dataStor(j,9,i), dataStor(j,10,i)
      NEXT i
   NEXT j
   IF EOF(#fileNo) THEN CLOSE #fileNo: EXIT SUB
   'now, read in data for advanced payments -------------------------------------------------
   INPUT #fileNo, numAdvEntries1, unused1
   INPUT #fileNo, numAdvEntries2, unused2
   IF numAdvEntries1 THEN
      DIM arrDate1(1 TO numAdvEntries1)
      DIM arrAdv1(1 TO numAdvEntries1)
      DIM arrPaid1(1 TO numAdvEntries1)
      FOR i = 1 TO numAdvEntries1
         INPUT #fileNo, arrDate1(i), arrAdv1(i), arrPaid1(i)
      NEXT i
   END IF
   IF numAdvEntries2 THEN
      DIM arrDate2(1 TO numAdvEntries2)
      DIM arrAdv2(1 TO numAdvEntries2)               
      DIM arrPaid2(1 TO numAdvEntries2)
      FOR i = 1 TO numAdvEntries2
         INPUT #fileNo, arrDate2(i), arrAdv2(i), arrPaid2(i)
      NEXT i
   END IF
   CLOSE #fileNo
   IF sVer < "1.60" THEN saveDataFile()
END SUB

SUB saveDataFile()
   'save data for 12 months of the monthly pub + ski + summer + octFest pubs
   LOCAL i, j, k, fileNo, unused1, unused2 AS LONG
   IF ISFILE(dataFile) THEN KILL dataFile
   IF storedYr = 0 THEN storedYr = VAL(RIGHT$(DATE$, 4))
   fileNo = FREEFILE
   OPEN dataFile FOR OUTPUT AS fileNo
   WRITE #fileNo, $ver, storedYr
   FOR j = 1 TO 15 'save 12 months + 3 seasonal pubs
      FOR i = 1 TO maxRows
         WRITE #fileNo, dataStor(j,1,i), dataStor(j,2,i), dataStor(j,3,i), dataStor(j,4,i),_
                        dataStor(j,5,i), dataStor(j,6,i), dataStor(j,7,i), dataStor(j,8,i),_
                        dataStor(j,9,i), dataStor(j,10,i)
      NEXT i
   NEXT j
   'now, save the data for advanced payments -------------------------------------------------
   WRITE #fileNo, numAdvEntries1, unused1
   WRITE #fileNo, numAdvEntries2, unused2
   IF numAdvEntries1 THEN
      FOR i = 1 TO numAdvEntries1
         WRITE #fileNo, arrDate1(i), arrAdv1(i), arrPaid1(i)
      NEXT i
   END IF
   IF numAdvEntries2 THEN
      FOR i = 1 TO numAdvEntries2
         WRITE #fileNo, arrDate2(i), arrAdv2(i), arrPaid2(i)
      NEXT i
   END IF
   CLOSE #fileNo
   dataChanged = 0
END SUB

SUB showStatus1(OPT BYVAL nMsg AS LONG)
   LOCAL msg, s AS STRING
   IF viewOnly THEN
      msg = "View only - navigate around without fear of changing any data"
   ELSE
      s = "... [ENTER] or move cell to save, [ESC] to cancel"
      SELECT CASE nMsg
         CASE 0: msg = "View only - navigate around without fear of changing any data"
         CASE 2, 4: msg = "select from pulldown list, up/down arrow, or mouse wheel" + s
         CASE 3: msg = "total number of ads sold for this ad" + s
         CASE 5: msg = "[c] or [SPACE] to toggle color on/off" + s
         CASE 6: msg = "computed from previous cell values but can be overridden" + s
         CASE 7: msg = "sale price actually paid" + s
         CASE 8: msg = "up/dn or mouse wheel to select status, ctrl+Up/Dn to select pickup" + s
         CASE 9: msg = "commission due computed from previous cell values" + s
         CASE 10: msg = "commission actually paid" + s
      END SELECT
   END IF
   STATUSBAR SET TEXT hMain, %IDC_Statusbar1, 1, 0, msg
END SUB
